#!/bin/sh
#
# Sophos Anti-Virus for Unix - Enterprise Manager installation/update script
# Copyright (c) 2003-2012 Sophos Limited. All rights reserved.
VAexit()
{
   
   
   
   if [ "$new_cid_list" != "" ] && [ "$new_cid_list" != "$central_install_dir/$cid_list" ]; then
     if [ -r $new_cid_list ]; then
       rm -f $new_cid_list
     fi
   fi
   if [ "$trusted_calcmd5" != "" ]; then
     if [ -r $trusted_calcmd5 ]; then
       rm -f $trusted_calcmd5
     fi
   fi
   if [ "$trusted_updcalc" != "" ]; then
     if [ -r $trusted_updcalc ]; then
        rm -rf $trusted_updcalc
      fi
   fi
 
   if [ "$upd_detected" ] && [ "$copy_file_list" ]; then
     if [ -r $copy_file_list ]; then
        rm -rf $copy_file_list
     fi
   fi
   if [ -r /tmp/sav_file_list ]; then
     rm -f /tmp/sav_file_list
   fi
   
   
   
   
   
   
   
   
   
   
   
   
   
   status=$1
   if [ "$extended_errcodes" = "yes" ]; then
     if [ $status -eq 0 ]; then
       status=0                            
       if [ "$vdl_updated" = "yes" ]; then
         status=1                          
         if [ "$libsavi_updated" = "yes" ]; then
           status=3                        
           if [ "$sweep_updated" = "yes" ]; then
              status=7                     
           fi
         elif [ "$sweep_updated" = "yes" ]; then
             status=5                      
         fi
       else 
         if [ "$libsavi_updated" = "yes" ]; then
           status=2                         
           if [ "$sweep_updated" = "yes" ]; then
             status=6                       
           fi
         elif [ "$sweep_updated" = "yes" ]; then
           status=4                         
         fi
       fi
     else 
       status=128                           
     fi
   fi
   exit $status
}
error()
{
   
   fecho 'Error:  ' $*
   VAexit 1
}
fecho()
{
   case "$verbose,$1" in
      [0-9],[0-9]) if [ $verbose -ge $1 ]; then shift; else return; fi;;
   esac
   echo $@
}
pathcontains()
{
  i=$IFS
  IFS=:
  for d in $1; do
    if [ "$d" = "$2" ]; then
      IFS=$i; return 1
     fi
  done
  IFS=$i
  return 0
}
emcopy()
{
  
  if [ "$wget" != "" ]; then
    cd $2
    
    
    $wget_program $wget_options $http_login $http_passwd  $proxy_user $proxy_passwd $1 > /dev/null 2> /dev/null
    if [ $? -eq 0 ]; then
      if [ -r $2/$3 ]; then
        return 0
       fi
    fi
    return 1
  fi
  if [ "$network_user" != "" ]; then
    if [ -r $2/$3 ]; then
      mv $2/$3 $2/$3.bak
    fi
    
    
    su - $network_user -c "cp -f $1 $2/$3"
    if [ -r $2/$3 ]; then
      
      rm -rf $2/$3.bak          
      return 0
    else
      
      if [ -r $2/3.bak ]; then
        mv $2/$3.bak $2/$3
      fi
      return 1
    fi
  else
    
    
    if [ ! -r $1 ]; then
      return 1
    else
      cp -f $1 $2/$3
    fi
    return 0
  fi
}
emread()
{
  if [ "$wget" != "" ]; then
    cd $2
    
    
    
    $wget_program $wget_options $http_login $http_passwd $proxy_user $proxy_passwd $1 > /dev/null 2> /dev/null
    if [ $? -eq 0 ]; then
      if [ -r $2/$3 ]; then
        return 0
       fi
    fi
    return 1 
  fi
  
  
  if [ "$network_user" != "" ]; then
    if [ -r $2/$3 ]; then
      mv $2/$3 $2/$3.bak
    fi
    
    res=`su - $network_user -c "if [ -r $1 ]; then echo OK; else echo NOK; fi"`
    if [ "$res" != "OK" ]; then
      return 1
    fi
    su - $network_user -c "cp -f $1 $2/$3"
    
    if [ -r $2/$3 ]; then
      
      rm -rf $2/$3.bak          
      return 0
    else
      
      if [ -r $2/3.bak ]; then
        mv $2/$3.bak $2/$3
      fi
      return 1
    fi
  else
    
    
    if [ ! -r $1 ]; then
      return 1
    fi
    return 0
  fi
}
emread_cidsync_upd_or_lst()
{
  cid_list=$cidsync_lst
  emread $1/$cidsync_lst $2 $cidsync_lst
  if [ $? -eq 0 ]; then
     upd_detected=
     return 0
  fi
  if [ "$enable_upd" = "yes" ]; then
    emread $1/$cidsync_upd $2 $cidsync_upd
    if [ $? -eq 0 ]; then
      upd_detected=yes
      cid_list=$cidsync_upd
      return 0
    fi
  fi
  return 1
}
check_type_of_file_updated()
{
  if [ "$extended_errcodes" != "yes" ]; then
    return
  fi
  
  echo "$filename" | grep "\.ide" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
    vdl_updated=yes
    return
  fi
  
  echo "$filename" | grep "^vdl" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
    vdl_updated=yes
    return
  fi
  
  
  echo "$filename" | grep "^sus" | grep "\.vdb" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
    vdl_updated=yes
    return
  fi
  
  echo "$filename" | grep "^libsavi" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
    libsavi_updated=yes
    return
  fi
  
  echo "$filename" | grep "sweep" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
    sweep_updated=yes
    return
  fi
  
  if [ "$filename" = "swpmess.dat" ]; then
    sweep_updated=yes
    return
  fi
  return
}
initialise()
{
  checksum=                     
  eminstall_conf="/etc/eminstall.conf" 
  em_install_icheckd=
  filename=                     
  finish_scan_command_line=
  install=
  install_commands=
  lastline=
  keep=                         
  extended_errcodes=            
  status=0                      
  vdl_updated=                  
  libsavi_updated=              
  sweep_updated=                
  savi_only=                    
  root_user="root"
  central_install_dir=          
  central_install_dir2=         
  central_install_dir3=         
  cache_install_dir= 
  calc_cidchecksum=
  enable_upd=yes
  upd_detected=
  cid_checksum=
  cidsync_lst="cidsync.lst"
  cidsync_upd="cidsync.upd"
  copy_file_list=               
                                
  if [ "$enable_upd" = "yes" ]; then
    cid_list=$cidsync_upd
  else
    cid_list=$cidsync_lst         
  fi
  cid_list_for_reporting="cidsync file"
  new_cid_list=                  
                                 
                                 
                                 
  protocol=" "
  protocol2=" "
  protocol3=" "
  sleeptime=30                   
  run_on_success=                
  tab="	" 
                                 
                                 
  tmp_cidfile=/tmp/cidlist.$$$
  tmp_filelist=/tmp/filelist.$$$
  trusted_calcmd5=               
  trusted_updcalc=               
  sav_ic_dir=
  sav_install_dir=
  sav_binary_dir=
  sav_lib_dir=
  sav_data_dir=
  sav_man_dir=
  version=303                    
                                 
  verbose=0
  wget=                          
  wget_program=                  
  wget_options=                  
                                 
  
  http_login=" "
  http_passwd=" "
  proxy_user=" "
  proxy_passwd=" "
  original_http_proxy=$http_proxy
  use_exported_http_proxy=
  http_proxy=" "
  ftp_proxy=" "
  http_login2=" "
  http_passwd2=" "
  proxy_user2=" "
  proxy_passwd2=" "
  http_proxy2=" "
  ftp_proxy2=" "
  http_login3=" "
  http_passwd3=" "
  proxy_user3=" "
  proxy_passwd3=" "
  http_proxy3=" "
  ftp_proxy3=" "
  network_user=                  
  
  
  
  
  if [ -d /sbin ]; then
    pathcontains $PATH /sbin
    if [ $? -eq 0 ]; then
       PATH=$PATH:/sbin
    fi
  fi
  if [ -d /usr/sbin ]; then
    pathcontains $PATH /usr/sbin
    if [ $? -eq 0 ]; then
       PATH=$PATH:/usr/sbin
    fi
  fi
  if [ -d /usr/local/bin ]; then
    pathcontains $PATH /usr/local/bin
    if [ $? -eq 0 ]; then
       PATH=$PATH:/usr/local/bin
    fi
  fi
  if [ -d /usr/local/man ]; then
    pathcontains $MANPATH /usr/local/man
    if [ $? -eq 0 ]; then
       MANPATH=$MANPATH:/usr/local/man
    fi
  fi
  
  
  
  
  
  
  
  can_use_variables=
  echo "****" > /tmp/sav_temp
  while read dummy; do
    can_use_variables=yes
  done < /tmp/sav_temp
  rm -rf /tmp/sav_temp
  
}
help_text()
{
  echo "Sophos Anti-Virus Enterprise Manager Installation Utility"
  echo "Copyright (c) 2003-2006 Sophos Plc, www.sophos.com"
  echo
  echo "Display this help text by using: eminstall.sh -h"
  echo 
  echo "This utility performs an Enterprise Manager installation or update by checking"
  echo "to see if the central installation directory has been updated.  If it has,"
  echo "then an updated version of Sophos Anti-Virus is installed." 
  echo
  echo "eminstall.sh should be set up so that it is run by a regular cron job. If"
  echo "no changes have occurred to the central installation directory, then nothing"
  echo "will be done."
  echo
  echo "You will need to set up a configuration file, $eminstall_conf, to tell"
  echo "eminstall.sh where the central installation directory and cache can be found"
  echo "as well as other details.  See below for details on $eminstall.conf."
  echo
  echo "Command line options:"
  echo "---------------------"
  echo
  echo "eminstall.sh -v            Verbose - give more details about what eminstall.sh"
  echo "                           is doing."
  echo "eminstall.sh -ninst        Download but do not install SAV for Unix - you will"
  echo "                           have to install it youself"
  echo "eminstall.sh -savi         Install SAVI components only, not SWEEP"
  echo "eminstall.sh -eec          Output exit code as extended error code"
  echo "                           0x00 - OK"
  echo "   These codes are bit {   0x01 - VDL or IDE files were updated"
  echo "   masks, i.e. SWEEP   {   0x02 - library (libsavi) was updated"
  echo "   and VDL updated     {   0x04 - SWEEP was updated"
  echo "   would be 0x05       {   "
  echo "                           0x80 - an error occurred"
  echo "                           Codes are given in hexadecimal"
  echo "eminstall.sh -r <program or script>"
  echo "                           After successful installation, run the"
  echo "                           program or script specfied.  Note that you"
  echo "                           may need to use the full path."
  echo
  echo "$eminstall_conf configuration file options:"
  echo "-----------------------------------------------"
  echo
  echo "More detailed control and configuration of eminstall.sh can be performed by"
  echo "using the configuration file $eminstall_conf."
  echo
  echo "Configuration file $eminstall_conf should be set up to tell eminstall.sh"
  echo "where the central installation directory is, and where the local cache"
  echo "directory is.  The central installation directory specifies a directory,"
  echo "probably on a remote machine, to which Enterprise Manager will download the"
  echo "latest updates of Sophos Anti-Virus.  (The directory may be accessible either"
  echo "via file-sharing, e.g. NFS, Samba, or via wget and http).  The cache directory"
  echo "is a directory local to this machine, which holds the last update of"
  echo "Sophos Anti-Virus."
  echo
  echo "You can also specify which directories SAV itself should be installed in,"
  echo "by setting values in the $eminstall.conf file."
  echo
  echo "The layout of eminstall.conf is:-"
  echo "EM install CID = <central installation directory for EM>"
  echo "EM cache dir = <cache directory for EM>"
  echo "SAV install dir=<SAV install directory prefix, e.g. /usr/local>"
  echo "SAV bin dir=<SAV bin directory, relative to install dir, e.g. bin>"
  echo "SAV library dir=<SAV library dir, relative to install dir, e.g. lib>"
  echo "SAV virus dir=<SAV virus dir, relative to install dir, e.g. sav>"
  echo "SAV man dir=<SAV man pages dir, relative to install dir, e.g. man>"
  echo "Verbose=<verbose level>, 0 or 1>"
  echo "Keep=<file 1 to be kept> <file 2 to be kept> etc."
  echo "protocol=<protocol to be used for obtaining files from CID - values"
  echo "          can be nfs or wget.  Default is file sharing.  If you set"
  echo "          wget then you must also set the wget= parameter, and"
  echo "          the EM install CID must be set to the url address where the"
  echo "          central installation files are to be found."
  echo "network user=<name of user to access network files>"
  echo "             If filesharing is used to obtain files from the CID, and"
  echo "             your root user does not have permission to access the CID"
  echo "             you can use this to specify a username which does have permissions."
  echo "             You must run eminstall.sh as root (the superuser) for this to work."
  
  echo "wget=<path to wget program>  This value only needs to be set if"
  echo "      the central installation files are to be downloaded via wget."
  echo "      Note that you should set protocol=wget, and that the EM install"
  echo "      CID must be set to the url address where central installation"
  echo "      files are to be found."
  echo "http-login=<wget --http-login= value>          { These parameters"
  echo "http-passwd=<wget --http-passwd= value>        { are only meaningful"
  echo "proxy-user=<wget --proxy-user= value>          { if you are using"
  echo "proxy-passwd=<wget --proxy-passwd= value>      { wget.  They allow"
  echo "http-proxy=<wget http_proxy env variable value>{ control of login,"
  echo "ftp-proxy=<wget ftp_proxy env variable value>  { password and proxy"
  echo "                                               { values."
  echo "wget-options=<options to be passed to wget>  Allows other wget options"
  echo "      to be passed to wget."
  echo
  echo "E.g. the lines:-"
  echo "SAV install dir=/usr/local"
  echo "SAV bin dir=bin"
  echo "would set the SAV install dir prefix to /usr/local, and the binary install"
  echo "directory to /usr/local/bin.  These values are optional and will be set to"
  echo "default values if not supplied.  You MUST, however specify the EM install CID"
  echo "and the EM cache dir."
  echo
  echo "Alternate locations can be specified so that if the EM install script"
  echo "has difficulty accessing one location it will try another instead."
  echo "You can specify up to three, so that as well as EM install CID there"
  echo "is EM install CID2 and EM install CID3.  Each is tried in turn, so"
  echo "that if EM install CID fails, EM install CID2 will be tried and then"
  echo "EM install CID3.   You can set a different protocol for each one, so"
  echo "they do not all need to be accessed via file sharing, or via wget."
  echo "If you are using wget then these will be urls, and an additional set"
  echo "of http-login, http-passwd, etc. values can also be set.  For example,"
  echo
  echo "EM install	CID = http://example-server/eminstall-cid"
  echo "EM install	CID2 = http://backup-servern/eminstall-cid"
  echo "EM install	CID3 = /mnt/server/central_install_dir"
  echo "http-login          = guest"
  echo "http-passwd         = guest"
  echo "http-login2         = guest"
  echo "http-passwd2        = guest"
  echo "protocol            = wget"
  echo "protocol2           = wget"
  echo "protocol3           = nfs"
  echo
  echo "This also applies to proxy-user, proxy-passwd, http-proxy and ftp-proxy."
  echo
  exit 0
}
EM_installation()
{
  
  initialise
  
  if [ ${#} -gt 0 ]; then
     while [ "$1" != "" ] && [ ! "$finish_scan_command_line" ]; do
       case "$1" in
         -h | -help)
             help_text
             ;;
         -c | -config)
             if [ "$2" ]; then
               eminstall_conf=$2
               shift
             fi
             ;;
         -v | -verbose)
             verbose=1
             ;;
         -r | -run)
               if [ "$2" ]; then
                 shift 
                 run_on_success=$*
                 finish_scan_command_line=yes
               fi
               ;;
         -eec) 
                extended_errcodes=yes
                ;;
         -ninst | --no-install) 
                install=no
                ;;
         -savi) 
                savi_only=yes
                ;;
         
         -use-exported-http-proxy | --use-exported-http-proxy)
                use_exported_http_proxy=yes
                ;;
         -no-use-exported-http-proxy | --no-use-exported-http-proxy)
                use_exported_http_proxy=no
                ;;
         *) help_text
            ;;
       esac
     shift
     done
  fi
  
  read_conf_file
  
  
  
  
  see_if_alternate_required
  
  
  see_if_update_required
  
  
  
  update_em_cache
  
  
  
  remove_unwanted_files
  
  
  
  set_execute_permissions
  
  
  
  if [ "$install" != "no" ]; then
    install_sav_for_unix
  fi
}
read_conf_file()
{
  
  
  if [ -r $eminstall_conf ]; then
    l=`egrep -i "^[ $tab]*em[ $tab]*install[ $tab]*cid[ $tab]*=" $eminstall_conf`
    test "$l" && central_install_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*em[ $tab]*cache[ $tab]*dir" $eminstall_conf`
    test "$l" && cache_install_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*install[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_install_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*bin[a-z]*[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_bin_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*lib[a-z]*[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_lib_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*virus[ $tab]*[a-z]*[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_data_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*man[ $tab]*[a-z]*[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_man_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
  
  
    l=`egrep -i "^[ $tab]*sav[ $tab]*ic[ $tab]*[a-z]*[ $tab]*dir" $eminstall_conf`
    test "$l" && sav_ic_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    if [ ! "$sav_ic_dir" ]; then
      l=`egrep -i "^[ $tab]*sav[ $tab]*intercheck[ $tab]*[a-z]*[ $tab]*dir" $eminstall_conf`
      test "$l" && sav_ic_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
      if [ ! "$sav_ic_dir" ]; then
        l=`egrep -i "^[ $tab]*sav[ $tab]*icheckd[ $tab]*[a-z]*[ $tab]*dir" $eminstall_conf`
        test "$l" && sav_ic_dir="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
      fi
    fi
  
    l=`egrep -i "^[ $tab]*verbose" $eminstall_conf`
    test "$l" && v="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    
    
    
    if [ "$v" != "" ]; then
      if [ "$v" = "0" ]; then
        verbose=0
      elif [ "$v" = "2" ]; then
        verbose=2
      else
        verbose=1
      fi
    fi
    l=`egrep -i "^[ $tab]*keep" $eminstall_conf`
    test "$l" && keep="`echo $l | sed -e 's/^.*= *//'`" 
    
    l=`egrep -i "^[ $tab]*wget[ $tab]*=" $eminstall_conf`
    test "$l" && wget_program="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    if [ "$wget_program" != "" ]; then
      if [ ! -r $wget_program ]; then
        error Cannot perform EM installation - cannot find $wget_program program
      fi
      if [ ! -x $wget_program ]; then
        error Cannot perform EM installation - $wget_program program is not executable
      fi
    fi
    
    l=`egrep -i "^[ $tab]*wget-options[ $tab]*" $eminstall_conf`
    
    test "$l" && wget_options="`echo $l | cut -f 2- -d = | sed -e 's/^ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-login[ $tab]*=" $eminstall_conf`
    test "$l" && http_login="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    l=`egrep -i "^[ $tab]*http-login[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && http_login2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    l=`egrep -i "^[ $tab]*http-login[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && http_login3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-passwd[ $tab]*=" $eminstall_conf`
    test "$l" && http_passwd="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-passwd[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && http_passwd2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-passwd[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && http_passwd3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-proxy[ $tab]*=" $eminstall_conf`
    test "$l" && http_proxy="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    
    l=`egrep -i "^[ $tab]*use[ $tab]*exported[ $tab]*http[ $tab]*proxy" $eminstall_conf`
    test "$l" && use_exported_http_proxy=yes
    
    l=`egrep -i "^[ $tab]*http-proxy[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && http_proxy2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*http-proxy[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && http_proxy3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*ftp-proxy[ $tab]*=" $eminstall_conf`
    test "$l" && ftp_proxy="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*ftp-proxy[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && ftp_proxy2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*ftp-proxy[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && ftp_proxy3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-user[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_user="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-user[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_user2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-user[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_user3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-passwd[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_passwd="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-passwd[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_passwd2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    l=`egrep -i "^[ $tab]*proxy-passwd[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && proxy_passwd3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*em[ $tab]*install[ $tab]*cid[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && central_install_dir2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*em[ $tab]*install[ $tab]*cid[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && central_install_dir3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*protocol[ $tab]*=" $eminstall_conf`
    test "$l" && protocol="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*protocol[ $tab]*2[ $tab]*=" $eminstall_conf`
    test "$l" && protocol2="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*protocol[ $tab]*3[ $tab]*=" $eminstall_conf`
    test "$l" && protocol3="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
  
    l=`egrep -i "^[ $tab]*network[ $tab]*user[ $tab]*=" $eminstall_conf`
    test "$l" && network_user="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
    
    
    
    
    if [ "$network_user" != "" ] && [ "$root_user" != "" ]; then
       touch /tmp/eminstall.$$$ > /dev/null 2> /dev/null
       chown $root_user /tmp/eminstall.$$$ > /dev/null 2> /dev/null
       err=$?
       rm -rf /tmp/eminstall.$$$
       if [ $err -ne 0 ]; then
         error "Cannot set network user if not running as superuser (root)".
       fi
    fi
  else
    error Cannot perform EM installation - no $eminstall_conf file found.  Run eminstall.sh -h for details 
  fi
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  fecho 1 EM Central installation directory is $central_install_dir
  fecho 1 EM Cache directory is $cache_install_dir
}
set_wget_to_protocol()
{
  wget=
  case $protocol in
    http | ftp | wget) wget=$wget_program;;
    *) wget=;;
  esac
}
check_if_existing_file_isnt_lower_case()
{
  case "$1" in
    readunix*)
      f=`echo $1 | sed -e 's/read/Read/g'`
      if [ -r "$central_install_dir"/$f ]; then
        filename=$f
        return
      fi;;
    install*) 
      f=`echo $1 | sed -e 's/install/Install/g'`
      if [ -r "$central_install_dir"/$f ]; then
        filename=$f
        return
      fi;;
   esac
}
make_existing_file_lower_case()
{
  case "$1" in
    Readunix*) 
     newfilename=`echo $1 | sed -e 's/Read/read/g'`
     return
     ;;
    Install*) 
     newfilename=`echo $1 | sed -e 's/Install/install/g'`
     return
     ;;
  esac
  newfilename=$1
}
see_if_alternate_required()
{
  if [ "$central_install_dir" = "" ]; then
     error Central install directory not set up
  fi
  if [ "$cache_install_dir" = "" ]; then
     error Cache install directory not set up
  fi
  
  
  
  if [ ! -d $cache_install_dir ]; then
    
    mkdir $cache_install_dir
    
    
    if [ "$network_user" != "" ]; then
      chmod a+w $cache_install_dir
    fi
  fi
  
  if [ -r $cache_install_dir/cid_sync.bak ]; then
    rm -f $cache_install_dir/cid_sync.bak
  fi
  
  if [ -r $cache_install_dir/cid_sync_upd.bak ]; then
    rm -f $cache_install_dir/cid_sync_upd.bak
  fi
  upd_detected=
  
  
  
  
  
  
  if [ -r $cache_install_dir/$cidsync_upd ]; then
    mv $cache_install_dir/$cidsync_upd $cache_install_dir/cid_sync_upd.bak
  fi
  if [ -r $cache_install_dir/$cidsync_lst ]; then
    mv $cache_install_dir/$cidsync_lst $cache_install_dir/cid_sync.bak
  fi
  
  set_wget_to_protocol
  if [ "$http_login" != " " ]; then
    http_login="--http-user=$http_login"
  fi
  if [ "$http_passwd" != " " ]; then
    http_passwd="--http-passwd=$http_passwd"
  fi
  
  
  if [ "$http_proxy" != " " ]; then
    export http_proxy
  
  elif [ "$use_exported_http_proxy" = "yes" ]; then
    http_proxy=$original_http_proxy
    export http_proxy
  fi
  if [ "$ftp_proxy" != " " ]; then
    export ftp_proxy
  fi
  if [ "$proxy_user" != " " ]; then
    proxy_user="--proxy-user=$proxy_user"
  fi
  if [ "$proxy_passwd" != " " ]; then
    proxy_passwd="--proxy-passwd=$proxy_passwd"
  fi
  emread_cidsync_upd_or_lst $central_install_dir $cache_install_dir
  if [ $? -ne 0 ]; then
    
    if [ "$central_install_dir2" != "" ]; then
      fecho 1 Cannot locate $cid_list_for_reporting at $central_install_dir, trying $central_install_dir2
      central_install_dir=$central_install_dir2
      if [ "$protocol2" != " " ]; then
        protocol=$protocol2
      fi
      set_wget_to_protocol
      if [ "$http_login2" != " " ]; then
        http_login="--http-user=$http_login2"
      fi
      if [ "$http_passwd2" != " " ]; then
        http_passwd="--http-passwd=$http_passwd2"
      fi
      if [ "$proxy_user2" != " " ]; then
        proxy_user="--proxy-user=$proxy_user2"
      fi
      if [ "$proxy_passwd2" != " " ]; then
        proxy_passwd="--proxy-passwd=$proxy_passwd2"
      fi
      
      
      if [ "$http_proxy2" != " " ]; then
        http_proxy=$http_proxy2; export http_proxy
      fi
      if [ "$ftp_proxy2" != " " ]; then
        ftp_proxy=$ftp_proxy2; export ftp_proxy
      fi
    else
        fecho 1 Could not read $cid_list_for_reporting at $central_install_dir, retrying 
        sleep $sleeptime
    fi
    emread_cidsync_upd_or_lst $central_install_dir $cache_install_dir
    if [ $? -ne 0 ]; then
      
      if [ "$central_install_dir3" != "" ]; then
        fecho 1 Cannot locate $cid_list_for_reporting at $central_install_dir, trying $central_install_dir3
        central_install_dir=$central_install_dir3
        if [ "$protocol3" != " " ]; then
          protocol=$protocol3
        fi
        set_wget_to_protocol
        if [ "$http_login3" != " " ]; then
          http_login="--http-user=$http_login3"
        fi
        if [ "$http_passwd3" != " " ]; then
          http_passwd="--http-passwd=$http_passwd3"
        fi
        if [ "$proxy_user3" != " " ]; then
          proxy_user="--proxy-user=$proxy_user3"
        fi
        if [ "$proxy_passwd3" != " " ]; then
          proxy_passwd="--proxy-passwd=$proxy_passwd3"
        fi
        
        
        if [ "$http_proxy3" != " " ]; then
          http_proxy=$http_proxy3; export http_proxy
        fi
        if [ "$ftp_proxy3" != " " ]; then
          ftp_proxy=$ftp_proxy3; export ftp_proxy
        fi
      else
        fecho 1 Could not read $cid_list_for_reporting at $central_install_dir, retrying 
        sleep $sleeptime
      fi
      emread_cidsync_upd_or_lst $central_install_dir $cache_install_dir
      if [ $? -ne 0 ]; then
        
        
        
        if [ -r $cache_install_dir/cid_sync_upd.bak ]; then
          mv $cache_install_dir/cid_sync_upd.bak $cache_install_dir/$cidsync_upd
        fi
        if [ -r $cache_install_dir/cid_sync.bak ]; then
          mv $cache_install_dir/cid_sync.bak $cache_install_dir/$cidsync_lst
        fi
        error Could not read $cid_list_for_reporting after 3 attempts, final location was $central_install_dir
      fi
    fi
  fi
  
  
  
  
  
  
  
  
  if [ -r $cache_install_dir/$cid_list ]; then
    new_cid_list="$cache_install_dir/cid_sync.new"
    mv $cache_install_dir/$cid_list $new_cid_list
  else
    new_cid_list="$central_install_dir/$cid_list"
  fi
  if [ -r $cache_install_dir/cid_sync.bak ]; then
    mv $cache_install_dir/cid_sync.bak $cache_install_dir/$cidsync_lst
  fi
  if [ -r $cache_install_dir/cid_sync_upd.bak ]; then
    mv $cache_install_dir/cid_sync_upd.bak $cache_install_dir/$cidsync_upd
  fi
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
}
see_if_update_required()
{
  if [ "$wget" = "" ] && [ "$central_install_dir" = "$cache_install_dir" ]; then
     error Central install directory and cache install directory are the same
  fi
  if [ "$wget" = "" ] && [ "$network_user" != "" ]; then
    result=`su - $network_user -c "if [ -d $central_install_dir ]; then echo OK; else echo FAIL; fi"`
    if [ "$result" != "OK" ]; then
      
      error cannot find EM central installation directory $central_install_dir
    fi
  elif [ "$wget" = "" ] && [ ! -d $central_install_dir ]; then
    
    error cannot find EM central installation directory $central_install_dir
  fi
  
  
  
  
  
  if [ -r $cache_install_dir/$cid_list ]; then
     diff $new_cid_list $cache_install_dir/$cid_list > /dev/null 2> /dev/null
     if [ $? -eq 0 ]; then
        fecho 1 Central installation list is identical, no need to update.
        VAexit 0
     fi
  fi
  
  if [ "$upd_detected" = "yes" ]; then
    updcalc=$cache_install_dir/updcalc
    if [ -r $updcalc ]; then
       if [ ! -x $updcalc ]; then
          chmod u+x $updcalc > /dev/null 2> /dev/null
       fi
    else
       emcopy $central_install_dir/updcalc $cache_install_dir updcalc
       if [ $? -ne 0 ]; then
         error Could not locate checksum program, cannot proceed with EM installation
       fi
       if [ ! -r $updcalc ]; then
         error Could not locate checksum program, cannot proceed with EM installation
       fi
       if [ ! -x $updcalc ]; then
         chmod u+x $updcalc > /dev/null 2> /dev/null
       fi
    fi
  else
  
  
  
  calcmd5=$cache_install_dir/calcmd5
  if [ -r $calcmd5 ]; then
     if [ ! -x $calcmd5 ]; then
        chmod u+x $calcmd5 > /dev/null 2> /dev/null
      fi
  else 
    emcopy $central_install_dir/calcmd5 $cache_install_dir calcmd5
    if [ $? -ne 0 ]; then
      error Could not locate checksum program, cannot proceed with EM installation
    fi
    if [ ! -r $calcmd5 ]; then
      error Could not locate checksum program, cannot proceed with EM installation
    fi
    if [ ! -x $calcmd5 ]; then
      chmod u+x $calcmd5 > /dev/null 2> /dev/null
    fi
  fi
  fi
  if [ "$upd_detected" = "yes" ]; then
    
    cid_checksum=`$updcalc -e $new_cid_list`
    
    
    calc_cidchecksum=`$updcalc -u $new_cid_list`
  else
  
  
  
  
  lastline=`cat $new_cid_list | sed -e '$!d'`
  cid_checksum=$lastline
  
  
  
  
  
  grep -v "$lastline" $new_cid_list > $tmp_cidfile 2> /dev/null
  calc_cidchecksum=`$calcmd5 $tmp_cidfile`
  rm -rf $tmp_cidfile
  fi
  if [ "$calc_cidchecksum" != "$cid_checksum" ]; then
      error Checksum error with new central installation cid list - aborting
  fi
  if [ ! -r $cache_install_dir/$cid_list ]; then
     fecho 1 EM installation cache list not found, updating cache...
  fi
}
update_em_cache()
{
  file_list=""
  if [ "$can_use_variables" = "" ] && [ -r /tmp/sav_file_list ]; then
    rm -f /tmp/sav_file_list
  fi
  if [ -r $cache_install_dir/updlist.tmp ]; then
    rm -rf $cache_install_dir/updlist.tmp
  fi
  if [ "$upd_detected" = "yes" ]; then
    trusted_updcalc=$updcalc.ok
    if [ -r $trusted_updcalc ]; then
      rm -f $trusted_updcalc
    fi
    cp -f $updcalc $trusted_updcalc
    copy_file_list=$cache_install_dir/updlist.tmp
    $trusted_updcalc -d $new_cid_list > $copy_file_list 2> /dev/null
  else
    trusted_calcmd5=$calcmd5.ok
    if [ -r $trusted_calcmd5 ]; then
      rm -f $trusted_calcmd5
    fi
    cp -f $calcmd5 $trusted_calcmd5
    copy_file_list=$new_cid_list
  fi
  
  if [ "$upd_detected" = "yes" ]; then
    fecho 1 Updating files using UPD format from EM central installation directory cache...
  else
    fecho 1 Updating files from EM central installation directory cache...
  fi
  
  
  
  
  
  
  
  grep "icheckd" $copy_file_list | grep -v "icheckd.1" | grep -v "icheckd.conf.5" > /dev/null 2> /dev/null
  if [ $? -eq 0 ]; then
      if [ "$sav_ic_dir" ]; then
        em_install_icheckd=yes
      fi
  fi
  while read filename checksum ; do
  
  
  
  
  if [ "$filename" != "$cid_checksum" ]; then
     
     
     
     if [ "$savi_only" = "yes" ]; then
       echo "$filename" | grep "sweep" > /dev/null 2> /dev/null
       
       if [ $? -eq 0 ]; then continue; fi
       echo "$filename" | grep "swpmess.dat" > /dev/null 2> /dev/null
       
       if [ $? -eq 0 ]; then continue; fi
       echo "$filename" | grep "icheckd" > /dev/null 2> /dev/null
       
       if [ $? -eq 0 ]; then continue; fi
       echo "$filename" | grep "icmess.dat" > /dev/null 2> /dev/null
       
       if [ $? -eq 0 ]; then continue; fi
     fi
     
     
     
     
     if [ -r $cache_install_dir/$filename ]; then
       if [ "$upd_detected" = "yes" ]; then
         calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
       else
         calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
       fi
       if [ "$calcdchecksum" = "$checksum" ]; then
         fecho 2 Checksum of $filename was same as central checksum file
         
         
         
         continue
       else
          fecho 2 Checksum of file $filename differs from that in EM list.
          fecho 2 Calculated checksum was $calcdchecksum, from list was $checksum
       fi
     fi
     
     
        
        
        
        
        
        
        
        rm -f $cache_install_dir/$filename
     
     
     
        
        
        if [ "$can_use_variables" = "" ]; then
          echo "$filename:$checksum" >> /tmp/sav_file_list
        else
          file_list="$file_list $filename:$checksum"
        fi
        if [ "$network_user" = "" ] && [ "$can_use_variables" != "" ]; then
          fecho 1 Updating $filename from EM installation CID to cache...
          emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ "$upd_detected" = "yes" ]; then
          if [ -r $cache_install_dir/$filename ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
            if [ "$calcdchecksum" = "$checksum" ]; then
              
              check_type_of_file_updated
              continue
            fi
          fi
        else
        
        if [ -r $cache_install_dir/$filename ]; then
          calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          if [ "$calcdchecksum" = "$checksum" ]; then
            
            check_type_of_file_updated
            continue
          fi
        fi
        fi
        
        
        
        
        
        
        fecho Checksum is incorrect on file $filename copied from CID - retrying copy...
        sleep $sleeptime
        rm -f $cache_install_dir/$filename
        emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ "$upd_detected" = "yes" ]; then
          if [ -r $cache_install_dir/$filename ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
            if [ "$calcdchecksum" = "$checksum" ]; then
              check_type_of_file_updated
              continue
            fi
          fi
        else
        chmod u+x $calcmd5 > /dev/null 2> /dev/null
        if [ -r $cache_install_dir/$filename ]; then
          calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          if [ "$calcdchecksum" = "$checksum" ]; then
            check_type_of_file_updated
            continue
          fi
        fi
        fi
        fecho Checksum is incorrect on file $filename copied from CID - final retry...
        sleep $sleeptime 
        rm -f $cache_install_dir/$filename
        emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ "$upd_detected" = "yes" ]; then
          chmod u+x $updcalc > /dev/null 2> /dev/null
          if [ -r $cache_install_dir/$filename ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
            if [ "$calcdchecksum" = "$checksum" ]; then
            check_type_of_file_updated
            continue
            fi
          fi
        else
        chmod u+x $calcmd5 > /dev/null 2> /dev/null
        if [ -r $cache_install_dir/$filename ]; then
          calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          if [ "$calcdchecksum" = "$checksum" ]; then
            check_type_of_file_updated
            continue
          fi
        fi
        fi
        error Abandoning update - $filename and central checksum list do not correspond
        fi
     
    else
      
      
      
      
      
      rm -f $cache_install_dir/$cid_list
      cp -f $new_cid_list $cache_install_dir/$cid_list
      if [ $? -ne 0 ]; then
        error Could not find file $central_install_dir/$cid_list
      fi
      if [ -r $cache_install_dir/$cid_list ]; then
        fecho 1 Validating checksum on $cid_list...
        if [ "$upd_detected" = "yes" ]; then
          calcdchecksum=`$trusted_updcalc -u $new_cid_list`
        else
        grep -v "$lastline" $cache_install_dir/$cid_list > $tmp_cidfile
        calcdchecksum=`$trusted_calcmd5 $tmp_cidfile`
        rm -rf $tmp_cidfile
        fi
        if [ "$calcdchecksum" != "$filename" ]; then
          error Checksum error - checksum of copied $cid_list is incorrect...
        fi
      else
        error $cid_list has not been copied into cache install dir...
      fi
    fi
  done < $copy_file_list
  
  
  
  
  if [ "$can_use_variables" = "" ]; then
    file_list=""
    if [ -r /tmp/sav_file_list ]; then
      file_list=`cat /tmp/sav_file_list`
      rm -f /tmp/sav_file_list
    fi
  fi
  if [ "$network_user" != "" ] || [ "$can_use_variables" = "" ]; then
    for file_and_checksum in $file_list; do
        filename=`echo $file_and_checksum | cut -d':' -f1`; checksum=`echo $file_and_checksum | cut -d':' -f2`
        fecho 1 Updating $filename from EM installation CID to cache...
        
        emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ -r $cache_install_dir/$filename ]; then
          if [ "$upd_detected" = "yes" ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
          else
            calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          fi
          if [ "$calcdchecksum" = "$checksum" ]; then
            
            check_type_of_file_updated
            continue
          fi
        fi
        
        
        
        
        
        
        
        fecho Checksum is incorrect on file $filename copied from CID - retrying copy...
        sleep $sleeptime
        rm -f $cache_install_dir/$filename
        emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ -r $cache_install_dir/$filename ]; then
          if [ "$upd_detected" = "yes" ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
          else
          calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          fi
          if [ "$calcdchecksum" = "$checksum" ]; then
            check_type_of_file_updated
            continue
          fi
        fi
        fecho Checksum is incorrect on file $filename copied from CID - final retry...
        sleep $sleeptime 
        rm -f $cache_install_dir/$filename
        emcopy $central_install_dir/$filename $cache_install_dir $filename
        if [ $? -ne 0 ]; then
          error Could not find file $central_install_dir/$filename in $cid_list
        fi
        if [ -r $cache_install_dir/$filename ]; then
          if [ "$upd_detected" = "yes" ]; then
            calcdchecksum=`$trusted_updcalc -c $cache_install_dir/$filename`
          else
            calcdchecksum=`$trusted_calcmd5 $cache_install_dir/$filename`
          fi
          if [ "$calcdchecksum" = "$checksum" ]; then
            check_type_of_file_updated
            continue
          fi
        fi
        error Abandoning update - $filename and central checksum list do not correspond
    done
  fi
  if [ "$trusted_calcmd5" ]; then
    if [ -r $trusted_calcmd5 ]; then
      rm -f $trusted_calcmd5
    fi
  fi
  if [ "$trusted_updcalc" ]; then
    if [ -r $trusted_updcalc ]; then
       rm -rf $trusted_updcalc
    fi
  fi
}
remove_unwanted_files()
{
  fecho 1 Removing files not required from EM install cache...
  
  
  if [ "$new_cid_list" != "$central_install_dir/$cid_list" ]; then
    if [ -r $new_cid_list ]; then
      rm -f $new_cid_list
    fi
  fi
  cd $cache_install_dir
  if [ ! -r $cid_list ]; then
    return
  fi
  ls > $tmp_filelist
  while read filename; do
    if [ "$upd_detected" ]; then
      echo grep "$filename" $copy_file_list >> /tmp/eek
      if [ "$filename" = "updlist.tmp" ]; then
         continue
      fi
      grep "$filename" $copy_file_list > /dev/null 2> /dev/null
      res=$?
      
      
      
      
      
    else
      grep "$filename" $cid_list > /dev/null 2> /dev/null
      res=$?
    fi
    
    
    if [ $res -ne 0 ]; then
      
      
      if [ "$filename" != "$cid_list" ]; then
        remove_file=yes
        
        if [ "$keep" != "" ]; then
          echo $keep | grep "$filename" > /dev/null 2> /dev/null
          if [ $? -eq 0 ]; then
            remove_file=no
          fi
        fi
        if [ "$remove_file" = "yes" ]; then
          fecho 1 Removing $filename - does not exist in $cid_list
          rm -f $filename
        fi
      fi
    fi
  done < $tmp_filelist
  rm -f $tmp_filelist
  
  if [ "$upd_detected" = "yes" ] && [ "$copy_file_list" ]; then
    if [ -r $copy_file_list ]; then
       rm -rf $copy_file_list
    fi
  fi
  
  
  if [ "$upd_detected" = "yes" ]; then
    if [ -r $cidsync_lst ]; then
       rm -rf $cidsync_lst
    fi
  fi
}
set_execute_permissions()
{
  
  if [ "$savi_only" != "yes" ]; then
    chmod u+x sweep                      
    chmod u+x icheckd
  fi
  chmod u+x libsavi*
  
  chmod u+x install.sh                 
}
install_sav_for_unix()
{
  
  
  
  cd $cache_install_dir
  install_commands=""
  if [ "$savi_only" = "yes" ]; then
    install_commands="$install_commands -savi"
  fi
  if [ "$sav_install_dir" != "" ]; then
    install_commands="$install_commands -d $sav_install_dir"
  fi
  if [ "$sav_bin_dir" != "" ]; then
    install_commands="$install_commands -b $sav_bin_dir"
  fi
  if [ "$sav_lib_dir" != "" ]; then
    install_commands="$install_commands -l $sav_lib_dir"
  fi
  if [ "$sav_data_dir" != "" ]; then
    install_commands="$install_commands -s $sav_data_dir"
  fi
  if [ "$sav_man_dir" != "" ]; then
    install_commands="$install_commands -m $sav_man_dir"
  fi
  
  if [ "$savi_only" != "yes" ]; then
  
  
    if [ ! "$em_install_icheckd" ]; then
      install_commands="$install_commands -ni"
    else
      
      
      
      
      install_commands="$install_commands -ssi"
      if [ "$sav_ic_dir" != "" ]; then
        install_commands="$install_commands -i $sav_ic_dir"
      fi
    fi
  fi
  if [ $verbose -gt 1 ]; then
    install_commands="$install_commands -v"
  fi
  
  fecho Installing updated files from EM installation cache...
  
  
  
  
  
  
  
  
  
  
  ./install.sh $install_commands -em -ri
  
  if [ $? -ne 0 ]; then
     error "EM update worked, but installation failed"
  else
     fecho EM installation successful
     if [ "$run_on_success" ]; then 
       $run_on_success
       if [ $? -ne 0 ]; then
         error "EM installation worked, but command executed on success failed"
       fi
     fi
  fi
}
EM_installation $*
VAexit 0
